//------------------------------------------------------------------------------
/** @file    	ux_gui.h
    @brief   	GUI ó ̺귯 
    @author  	â bmfrog2@gmail.com
    @author  	̿
    @author  	
	@date 		2007 5 25
	@license 	GPLv2
*///----------------------------------------------------------------------------

#include <gx.h>
#include <gxbmp.h>

#ifndef _UX_GUI_
#define _UX_GUI_

#define	TRACE 		printf("< %s :%d >\n", __FUNCTION__ , __LINE__)

#ifdef __cplusplus
extern "C"
{
#endif


	int 		ux_gui_lib_init						( int exit_flag );											//  gui ̺ ʱȭ Ѵ.
	int 		ux_gui_screen_map_load				( char *filename );											// ũ   о ó Ѵ. 
	int 		ux_gui_screen_map_set_dc			( dc_t	*dc );												//  DC Ѵ. 
	int 		ux_gui_screen_map_draw_front		( void );													//  ȭ ׸. 
	int 		ux_gui_screen_map_put_ie_event		( ie_event_t *event_data  );								// ̺Ʈ ͸ Ѱ  ó Ѵ. 
	int 		ux_gui_screen_map_get_area			( void );													//  ε Ѵ.
	int 		ux_gui_screen_map_draw_area_front	( int area_index );											//   ׸. 	
	int 		ux_gui_screen_map_draw_area_back	( int area_index );											//   ׸.
	
	int 		ux_gui_screen_map_mark_button		( int area_index );											// ũ  ڿ  ư  ǥ Ѵ. 	
	
	int 		ux_gui_screen_map_draw_button_down	( int area_index );											// ư ٿ  ׸.
	int 		ux_gui_screen_map_draw_button_up	( int area_index , int msec_delay );						// ư msec    ׸.
	
	int 		ux_gui_screen_map_get_mouse_pos		( int *x, int *y );											// 콺 ġ ´. 

#ifdef __cplusplus
}
#endif

//------------------------------------------------------------------------------
//
//   
//
//------------------------------------------------------------------------------

#endif  // _UX_GUI_
