//------------------------------------------------------------------------------
//    : sample_gx_main.c
// Ʈ : fwp
//      : 1) ex + ix + gx  
//            2 콺 ׸ ׸  
//    : â, ̿, ,̿ 
//    : 2009 311 
//    :
//    :
//      :
// ̼ : BSD
//------------------------------------------------------------------------------
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>                     // O_RDWR , O_NOCTTY   
#include <linux/input.h>

#include <gx.h>
#include <ex.h>
#include <ix.h>

//--------------------------------------------------------------
//   
//--------------------------------------------------------------
static dc_t 		*dc_screen;			 
static color_t 		fwp_pen_color;			//       

//--------------------------------------------------------------
//  : IE_XXX ̺Ʈ ó ϴ° Դϴ. ڰ ϴº α׷ 
//        ⿡ ߰Ͻø ˴ϴ. 
//--------------------------------------------------------------
int fwp_ix_event_handler(ie_event_t *event_data)
{	

	// ڵ带 ߰ϼ. ............
	
	switch(event_data->type)
	{
	case IE_MOUSE_DOWN	:
		// 콺    ڵϼ.!!! 
		printf("\rIE_MOUSE_DOWN x:%d , y:%d \n" ,event_data->data.mouse.x ,event_data->data.mouse.y);				 	
		gx_move_to( dc_screen, event_data->data.mouse.x, event_data->data.mouse.y); 
		break;
		
	case IE_MOUSE_UP 	:
		// 콺 ư   Ҷ  ڵϼ.!!! 
		printf("\rIE_MOUSE_UP   x:%d , y:%d \n" ,event_data->data.mouse.x ,event_data->data.mouse.y);
		break;

	case IE_MOUSE_MOVE :		
		// 콺    ڵϼ.!!! 
		printf("\rIE_MOUSE_MOVE    x:%d , y:%d \n" ,event_data->data.mouse.x ,event_data->data.mouse.y);

		// ȭ鿡  ׸  ߰ߴ. - imesu 
		gx_line_to(dc_screen,event_data->data.mouse.x, event_data->data.mouse.y );
		break;
		
	case IE_MOUSE_DOUBLE_CLICK :
		printf("\rIE_MOUSE_DOUBLE_CLICK  x:%d , y:%d \n" ,event_data->data.mouse.x ,event_data->data.mouse.y );               
		break;
		
	default : break;	
	}
 	return 0;
} 

//--------------------------------------------------------------
//  : smaple_fwp_main ϴ ʱȭ 
//--------------------------------------------------------------
void fwp_init( void )
{
	// ʱȭ  ־ ּ. 
}

//--------------------------------------------------------------
//  :fwp ϴ lib Ѵ. 
//  : ʺڴ ״ ϼ մϴ. 
//--------------------------------------------------------------
int fwp_lib_setting(void)
{

	if( gx_init( "/dev/fb"))					// gxLib ʱȭ
	{
		gx_print_error("gx init error\n");		//     
		return -1;
	}
	else
	{
		if(!(dc_screen=gx_get_screen_dc()))		// ߻ϸ 1 Ѵ.
		{
			gx_print_error("dc Get fail\n");
		}
 
	}
	fwp_pen_color = gx_color(255,0,0,255);		// pen  Ѵ. 		
	
	if( ex_init( EX_WAIT_TIME_DEFAULT ) )		// ex lib ʱȭ Ѵ.					
	{
		ex_print_error("\n");
		exit(0);
	}


	if( ix_init() )								// ix lib ʱȭѴ.
	{
		ix_print_error(" ");
		return -1;
	}

	ix_set_mouse_double_click_intaval(300);		// 콺  Ŭ  300msec Ѵ. 
	
	if(ix_auto_scan_open(IX_TMP_PATH_DEFAULT))	 // Է ̹ ڵ˻  openó
	{
		ix_print_error(" ");
		return -1;
	}	


	return 0;
}

 
//--------------------------------------------------------------
//  : 콺  ȭ鿡 ǥϴ Դϴ. 
//--------------------------------------------------------------
int main( int argc, char **argv )
{	
	fwp_init();	

	fwp_lib_setting();										// fwp ϴ ̺귯 ʱȭ 	
 
	ix_add_event( fwp_ix_event_handler );					// ̺Ʈ óԼ Ѵ.	
	
	while( 1 )
	{
		if( ex_loop() )
		{
			 ex_print_error("\n");
			 exit(0);
		}
	}	
	gx_close();

	return 0;
}

