//------------------------------------------------------------------------------
//    : sample_ix_main.c
// Ʈ : fwp
//      : ܼ  
//    : â, ̿, 
//    : 2009 1 13
//    :
//    :
//      :
// ̼ : BSD
//------------------------------------------------------------------------------
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>                     // O_RDWR , O_NOCTTY   
#include <linux/input.h>

#include <ex.h>
#include <ix.h>

#define TRACE printf("\rTRACE %s:%d \n",__FILE__,__LINE__);

//--------------------------------------------------------------
//  : Ű ° Ȯ (Shitf, ALT, CTRL, Ű....)
//        Ű  ̶ ( , ڸ    Ѵ. )
//--------------------------------------------------------------
int get_button_state(int state)
{	
	printf("state :");
	if(state & IX_MOUSE_BTN_LEFT)				printf("IX_MOUSE_BTN_LEFT /");
	if(state & IX_MOUSE_BTN_RIGHT)				printf("IX_MOUSE_BTN_RIGHT /");
	if(state & IX_MOUSE_BTN_MIDDLE)				printf("IX_MOUSE_BTN_MIDDLE /");
	printf("\n");		
	return 0;	
}

//--------------------------------------------------------------
//  : Է ̽ ̺Ʈ ó
//--------------------------------------------------------------
int test_input_event(ie_event_t *event_data)
{

	switch(event_data->type)
	{

	case IE_MOUSE_DOWN	:
		printf("IE_MOUSE_DOWN x:%d , y:%d " ,event_data->data.mouse.x ,event_data->data.mouse.y);
		get_button_state((int)event_data->data.mouse.state);
		break;

	case IE_MOUSE_UP 	:
		printf("IE_MOUSE_UP   x:%d , y:%d " ,event_data->data.mouse.x ,event_data->data.mouse.y);
		get_button_state((int)event_data->data.mouse.state);
		break;

	case IE_MOUSE_MOVE :
		printf("IE_MOUSE_MOVE   x:%d , y:%d " ,event_data->data.mouse.x ,event_data->data.mouse.y );
		get_button_state((int)event_data->data.mouse.state );
		break;
	}
	printf("\n");

	return 0;
}

//--------------------------------------------------------------
//  : ߻ ̺Ʈ Ͽ Ʈ!
//--------------------------------------------------------------
int sample_read(void)
{
	int x =0;
	int y =0;

	printf("read\n");
	ix_get_mouse_position(&x, &y);				// 콺  ǥ  ´. 
	printf("x = %d, y= %d\n",x,y);

	while( 1 )
	{
		if( ex_loop() )
		{
			 ex_print_error("\n");
			 exit(0);
		}
	}
}

//--------------------------------------------------------------
//  : 콺 ư . 
//--------------------------------------------------------------
int sample_write_mouse_button_action(void)
{
	ix_write_mouse_button_action(IX_MOUSE_BTN_LEFT, IE_MOUSE_DOWN);
	ix_write_mouse_button_action(IX_MOUSE_BTN_LEFT, IE_MOUSE_UP);	
	printf("ix_write_mouse_button_action..btn:IX_MOUSE_BTN_LEFT \n");

	
	ix_write_mouse_button_action(IX_MOUSE_BTN_RIGHT, IE_MOUSE_DOWN);
	ix_write_mouse_button_action(IX_MOUSE_BTN_RIGHT, IE_MOUSE_UP);	
	printf("ix_write_mouse_button_action..btn:IX_MOUSE_BTN_LEFT \n");

	
	ix_write_mouse_button_action(IX_MOUSE_BTN_MIDDLE, IE_MOUSE_DOWN);
	ix_write_mouse_button_action(IX_MOUSE_BTN_MIDDLE, IE_MOUSE_UP);	
	printf("ix_write_mouse_button_action..btn:IX_MOUSE_BTN_LEFT \n");
	return 0;
}

//--------------------------------------------------------------
//  :
//--------------------------------------------------------------
int main( int argc, char **argv )
{
	if(argc < 2)
	{
		printf("α׷  ּ !!\n");
		printf("1> ./ix_write_mouse_button_action.bin write\n");
		printf("2> ./ix_write_mouse_button_action.bin read\n");
		return 0;
	}

	if( ex_init( EX_WAIT_TIME_DEFAULT ) )							// ex lib ʱȭ Ѵ.
	{
		ex_print_error("\n");
		exit(0);
	}

	if( ix_init() )													// ix lib ʱȭѴ.
	{
		ix_print_error("\n");
		exit(0);
	}

	if(ix_auto_scan_open(IX_TMP_PATH_DEFAULT))						// Է ̹ ڵ˻  openó
	{
		ix_print_error("\n");
		exit(0);
	}

	ix_add_event( test_input_event );								// ̺Ʈ óԼ Ѵ.

	if(!memcmp(*(argv+1), "read"  , 4)) sample_read();
	if(!memcmp(*(argv+1), "write" , 4)) sample_write_mouse_button_action();	// 콺 ư .  


	return 0;
}


