//------------------------------------------------------------------------------
/** @file    	ix.h
    @brief   	Է ̺Ʈ ó ̺귯  
    @author  	â bmfrog2@gmail.com
    @author  	̿
    @author  	 imesu76@gmail.com
	@date 		2009 1 17
	@license 	GPLv2
*///----------------------------------------------------------------------------

#ifndef _IX_HEADER_
#define _IX_HEADER_


#define	FILE_NAME_INPUT_INFO_BASE		"/proc/bus/input/devices"					/**< ̽ ġ  */
#define	IX_TMP_PATH_DEFAULT				"/tmp"										/**<  mknod ϱ ӽ  */

#define FLAG_SET						1
#define FLAG_RELEASE					0


#define IX_INPUT_DEVICE_MAX				16

#define IXERR_NONE						0                   //IXERR_NONE  */
#define IXERR_READ						1                   //IX READ ERROR  */
#define IXERR_FD						2                   //IX FD ERROR  */
#define IXERR_DEV_INFO_OPEN				3  	                //IXERR_DEV_INFO_OPEN  */
#define IXERR_AUTOSCAN_SCANDEVICE   	4					/**<  ix_auto_scan_open Լ  ix_scan_device   */
#define IXERR_AUTOSCAN_MKNOD			5					/**<  ix_auto_scan_open Լ  mknod "  */
#define IXERR_AUTOSCAN_DEVICE_OPEN  	6                   /**<  ix_auto_scan_open Լ  ̽  "  */
#define IXERR_AUTOSCAN_EX_ADD        	7                   /**<  ix_auto_scan_open Լ  ex Լ  "  */
#define IXERR_WRITE_EVENT 		       	8                   /**<  ix_write_event_low Լ  ߸  "  */
#define IXERR_WRITE_MOUSE_BUTTON_EVENT 	9                   /**<  ix_write_mouse_button_action Լ  ߸  " */
#define IXERR_WRITE_KEYBOARD_EVENT		10					/**<  ix_write_keyboard_key_action Լ  ߸  "  */


#define	IX_KEY_VAULE_UP					1					/**<  Űư    */
#define	IX_KEY_VAULE_DOWN				2					/**<  Űư   */
#define	IX_KEY_VAULE_PRESS				4					/**<  ŰƮ DOWN->UP  , Ű ڵ尪 CODE ȯϴ.   */
//#define	IX_KEY_VAULE_REPEAT			8					/**<  Űư    ( )  */

#define	IX_MOUSE_VAULE_UP				0					/**<  콺  ư   */
#define	IX_MOUSE_VAULE_DOWN				1					/**<  콺  ư    */

//---------------------------------------------------------------------------------
// Ʈ ũ 
//---------------------------------------------------------------------------------
#define IX_MOUSE_BTN_LEFT				0x00000001			/**<  콺  ư  */
#define IX_MOUSE_BTN_RIGHT				0x00000002			/**<  콺  ư  */
#define IX_MOUSE_BTN_MIDDLE				0x00000004			/**<  콺 ũ ư  */


#define IX_KEYBOARD_BTN_LEFT_SHIFT		0x80000000			/**<  Ű  SHIFT  */
#define IX_KEYBOARD_BTN_RIGHT_SHIFT		0x40000000			/**<  Ű  SHIFT  */

#define IX_KEYBOARD_BTN_LEFT_ALT		0x20000000			/**<  Ű  ALT  */
#define IX_KEYBOARD_BTN_RIGHT_ALT		0x10000000			/**<  Ű  ALT  */
  
#define IX_KEYBOARD_BTN_LEFT_CTRL		0x08000000			/**<  Ű  CTRL  */
#define IX_KEYBOARD_BTN_RIGHT_CTRL		0x04000000			/**<  Ű  CTRL  */

#define IX_KEYBOARD_CAPSLOCK			0x02000000			/**<  Ű Caps Lock ư  */
#define IX_KEYBOARD_NUMLOCK				0x01000000			/**<  Ű Num Lock ư  */

#define IX_KEYBOARD_UP					0x00800000			/**<  Ű   	Ű  */
#define IX_KEYBOARD_DOWN				0x00400000			/**<  Ű Ʒ 	Ű  */
#define IX_KEYBOARD_LEFT				0x00200000			/**<  Ű  		Ű ư */
#define IX_KEYBOARD_RIGHT				0x00100000			/**<  Ű  	Ű ư   */

#define IX_MOUSE_FLAG_BTN_DOWN			0x00000001			/**<  콺 ư   */
#define IX_MOUSE_FLAG_BTN_UP			0x00000002			/**<  콺 ư   */
#define IX_MOUSE_FLAG_MOVE				0x00000004			/**<  콺   */
#define IX_MOUSE_FLAG_DOUBLE_CLICK		0x00000008			/**<  콺   */



#define IX_SCREEN_X_DEFAULT				640					/**<  ũ X   */
#define IX_SCREEN_Y_DEFAULT				480					/**<  ũ Y   */

#define IX_CAL_TOUCH_INFO_MAX			4					/**<  ǥ Է ִ    */

#if 0//wj@@test-touch
#define IX_CAL_TOUCH_INFO_OFSSET		1				/**<  TOUCH SCREEN    */
#else
#define IX_CAL_TOUCH_INFO_OFSSET		0x00010000          /**<  (1<< 16) TOUCH SCREEN    */
#endif



#define IX_MOUSE_DOUBLE_CLICK_TIME_INTAVAL	   500			/**<  500msec = 0.5  	  */

//---------------------------------------------------------------------------------
//   ̺Ʈ ޽
//---------------------------------------------------------------------------------
#define IE_MOUSE_DOWN					1				 /**< 콺  (APP ̺Ʈ)  */
#define IE_MOUSE_UP 					2				 /**< 콺 ư (APP ̺Ʈ)  */
#define IE_MOUSE_DOUBLE_CLICK			3				/**< 	콺  Ŭ // imesu-2009-03-02 */
#define IE_MOUSE_MOVE   				4				 /**< 찡 (APP ̺Ʈ)  */
#define IE_KEY_PRESS 					5				 /**< Ű ȴ    */
#define IE_KEY_DOWN 					6				 /**< Ű   */
#define IE_KEY_UP 						7				 /**< Ű    */

typedef struct input_event ix_event_t;					// kernel  ִ ̺Ʈ ü /include/linux/input.h


//------------------------------------------------------------------------------
/**
 @brief  Է ġ    ü 
*///----------------------------------------------------------------------------
typedef struct
{
	int     fd;					/**< ũ  */
	char 	name[128];			/**< ġ ̸  */
	int 	input_number;		/**< Էġ ȣ  */
	int 	event_number;		/**< event ġ ȣ  */

	int 	dev_major;			/**< ġ ֹȣ  */
	int 	dev_minor;			/**< ġ ιȣ  */

	int		is_touch;			/**< ġ ̽ ̸ 1, ƴϸ 0  */

} ix_mng_t;						

//------------------------------------------------------------------------------
/**
 @brief ư  ڷ
*///----------------------------------------------------------------------------
typedef  unsigned long ix_btn_state_t;	/**<  */


//------------------------------------------------------------------------------
/**
 @brief ġũ(tx, ty) , lcd ũ(sx, sy) ǥ  ü 
*///----------------------------------------------------------------------------

typedef struct {
	int  tx;					/**< touch screen xǥ */
	int  ty;					/**< touch screen yǥ */

	int  sx;					/**<  lcd screen xǥ */
	int  sy;					/**<  lcd screen yǥ */
}ix_cal_touch_info_t;


//------------------------------------------------------------------------------
/**
 @brief ġũ Ǵ ü 
*///----------------------------------------------------------------------------
typedef struct {
	int  xa;					/**<   */
	int  xb;					//

	int  ya;					/**<   */
	int  yb;					//
}ix_adjust_touch_info_t;


//------------------------------------------------------------------------------
/**
 @brief 콺 x,y ǥ     ü 
*///----------------------------------------------------------------------------
typedef struct {
	int				x;			/**<  x ǥ */
	int				y;			/**<  y ǥ */
	ix_btn_state_t  state;		/**<   */

}ie_mouse_t;


//------------------------------------------------------------------------------
/**
 @brief ŰԷ     ü 
*///----------------------------------------------------------------------------
typedef struct {
	int				key;		/**<  Է ǥ */
	ix_btn_state_t  state;		/**<   */
}ie_key_t;



//------------------------------------------------------------------------------
/**
 @brief Է ġ  ̺Ʈ ͸  ü 
*///----------------------------------------------------------------------------
typedef struct {
	int		type;				/**<  Է°  */
	union{
		ie_mouse_t		mouse;	/**<  콺 Է */
		ie_key_t		key;	/**<  keyboard Է */
	}data;
}ie_event_t;


//------------------------------------------------------------------------------
/**
 @brief ̺Ʈ  .....
*///----------------------------------------------------------------------------
typedef      int (*ix_event_func_t) (ie_event_t *event_data);

#ifdef __cplusplus
extern "C"
{
#endif


	void 		ix_print_error				( char *msg );								// ޽  
	void		ix_debug_disp_event_data	( ix_event_t *event_data );					//  ̺Ʈ   ǥѴ.


	int 		ix_init						( void );
	int			ix_auto_scan_open			( char *path );								// 1)Է ġ ڵ ˻
																						// 2) mknod
																						// 3) ̽  ..
																						// 4) ex Լ 
																						
	int 		ix_get_touch_fd				( char *path );								// ġ ũ  ũ͸ Ѵ. 

	int 		ix_add_event				( ix_event_func_t func );					//̺Ʈ ͸ ó Լ Ѵ.
	int 		ix_scan_device				( void );									// Է ġ  ˻Ѵ.

	int 		ix_read_event_data_low		( int fd,  ix_event_t *event_data );		//̺Ʈ  ͸ о °
	int 		ix_read_keyboard_low		( int fd,  int *key, int *key_state );		//Ű  о ´.
	int 		ix_read_key_press_low		( int fd,  int *key );						//Ű尡  
	int 		ix_read_touch_low			( int fd,  int *x, int *y, int *press );	// touch  о ´.
	int 		ix_read_mouse_low			( int fd,  int *x, int *y, int *btn);		//콺 Է°  ´.
	int 		ix_set_screen_size			( int x ,  int y);

	int			ix_write_event_low			( int fd, ix_event_t *event_data );			//̺Ʈ ġ ڰ  ̺Ʈ  ־ ̺Ʈ ߻Ų.
	int			ix_write_mouse_button_action( int mouse_button, int action );			//콺 Ưư Up down  ̺Ʈ ߻Ų.
	int			ix_write_mouse_rel_move		( int rel_x, int rel_y );					//콺  ġ  ̺Ʈ ߻Ų.
	int			ix_write_mouse_abs_move		( int abs_x, int abs_y );					//콺  ġ  ̺Ʈ ߻Ų.
	int			ix_write_keyboard_key_action( int keyboard_key, int action);			//Ű忡 Ű ̺Ʈ ߻Ų.
	int			ix_write_key_char_press		( char key );								//Ű忡 key press  ִ´. 

	int			ix_get_mouse_position		( int *x,  int *y );						// 콺  ġ ´.
	int			ix_set_mouse_double_click_intaval( int msec );							// 콺  Ŭ   
	int			ix_get_key_value			( int *key );								// keyboard Է° ´.


	int			ix_adjust_touch				( void );									// touch screen Ѵ.
	//int 		ix_get_touch_position		( int *x, int *y );							// ġ ũ  ġ  ´. 
    int         ix_get_touch                ( int x_tch, int y_tch, int *x_scr_ptr, int *y_scr_ptr );
    int         ix_get_touch_info           ( ix_adjust_touch_info_t *info );
    int         ix_set_touch                ( ix_adjust_touch_info_t *info );
    int         ix_print_touch              ( void );
    int         ix_adjust_touch_init        ( void );


#ifdef __cplusplus
}
#endif

//------------------------------------------------------------------------------
//   
//------------------------------------------------------------------------------


#ifndef _IX_VAR_

#endif

#endif  // _IX_HEADER_
