//------------------------------------------------------------------------------
//    : sample_gx_main.c
// Ʈ : fwp
//      : 1) ex + ix + gx  
//            2 콺 ׸ ׸  
//    : â, ̿, ,̿ 
//    : 2009 311 
//    :
//    :
//      :
// ̼ : BSD
//
//------------------------------------------------------------------------------

/*<>
IE_KEY_DOWN  low_key:44   
key state :

IE_KEY_PRESS    key:z  
key state :

IE_KEY_UP   low_key:44   Ǿϴ
key state :




IE_KEY_DOWN  low_key:45   
key state :

IE_KEY_PRESS    key:x  
key state :

IE_KEY_UP   low_key:45   Ǿϴ
key state :




IE_KEY_DOWN  low_key:46   
key state :

IE_KEY_PRESS    key:c  
key state :

IE_KEY_UP   low_key:46   Ǿϴ
key state :
*/
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>                     // O_RDWR , O_NOCTTY   
#include <linux/input.h>

#include <gx.h>
#include <ex.h>
#include <ix.h>




//--------------------------------------------------------------
//   
//--------------------------------------------------------------
static dc_t 		*dc_screen;			 
static color_t 		fwp_pen_color;			//       

//--------------------------------------------------------------
//  : Ű ° Ȯ (Shitf, ALT, CTRL, Ű....)
//        Ű  ̶ ( , ڸ    Ѵ. )
//--------------------------------------------------------------
int get_button_state(int state)
{	
	printf("key state :");
	if(state & IX_KEYBOARD_BTN_LEFT_SHIFT)		printf("IX_KEYBOARD_BTN_LEFT_SHIFT /");
	if(state & IX_KEYBOARD_BTN_RIGHT_SHIFT)		printf("IX_KEYBOARD_BTN_RIGHT_SHIFT /");
	if(state & IX_KEYBOARD_BTN_LEFT_ALT)		printf("IX_KEYBOARD_BTN_LEFT_ALT /");
	if(state & IX_KEYBOARD_BTN_RIGHT_ALT)		printf("IX_KEYBOARD_BTN_RIGHT_ALT /");
	if(state & IX_KEYBOARD_BTN_LEFT_CTRL)		printf("IX_KEYBOARD_BTN_LEFT_CTRL /");

	if(state & IX_KEYBOARD_BTN_RIGHT_CTRL)		printf("IX_KEYBOARD_BTN_RIGHT_CTRL /");
	if(state & IX_KEYBOARD_CAPSLOCK)			printf("IX_KEYBOARD_CAPSLOCK /");
	if(state & IX_KEYBOARD_NUMLOCK)				printf("IX_KEYBOARD_NUMLOCK /");

	if(state & IX_KEYBOARD_UP)					printf("IX_KEYBOARD_UP /");
	if(state & IX_KEYBOARD_DOWN)				printf("IX_KEYBOARD_DOWN /");
	if(state & IX_KEYBOARD_LEFT)				printf("IX_KEYBOARD_LEFT /");
	if(state & IX_KEYBOARD_RIGHT)				printf("IX_KEYBOARD_RIGHT /");
	printf("\n");		
	return 0;	
}

//--------------------------------------------------------------
//  : IE_XXX ̺Ʈ ó ϴ° Դϴ. ڰ ϴº α׷ 
//        ⿡ ߰Ͻø ˴ϴ. 
//--------------------------------------------------------------
int fwp_ix_event_handler(ie_event_t *event_data)
{	

	// ڵ带 ߰ϼ. ............	
	switch(event_data->type)
	{
	case IE_KEY_PRESS :
		printf("\rIE_KEY_PRESS    key:%c  \n" ,event_data->data.key.key );
		get_button_state((int) event_data->data.key.state);

		// Ű尡   ȭ鿡 ǥѴ. 
		gx_clear( dc_screen, gx_color( 0, 0, 0, 255));
		gx_text_out( dc_screen, 120 , 140, (char *)&event_data->data.key.key);		
		break;
		
	case IE_KEY_DOWN 	:
		printf("\rIE_KEY_DOWN  low_key:%d   \n",event_data->data.key.key );
		get_button_state((int) event_data->data.key.state);	
		break;

	case IE_KEY_UP 		:
		printf("\rIE_KEY_UP   low_key:%d   Ǿϴ\n" ,event_data->data.key.key );
		get_button_state((int) event_data->data.key.state);
		break;
	}
	
	printf("\n");
 	return 0;
} 

//--------------------------------------------------------------
//  : smaple_fwp_main ϴ ʱȭ 
//--------------------------------------------------------------
void fwp_init( void )
{
	// ʱȭ  ־ ּ. 
}

//--------------------------------------------------------------
//  :fwp ϴ lib Ѵ. 
//  : ʺڴ ״ ϼ մϴ. 
//--------------------------------------------------------------
int fwp_lib_setting(void)
{
	if( gx_init( "/dev/fb"))					// gxLib ʱȭ
	{
		gx_print_error("gx init error\n");		//     
		return -1;
	}
	else
	{
		if(!(dc_screen=gx_get_screen_dc()))		//ũ DC  ´. 
		{
			gx_print_error("dc Get fail\n");
		}
		
		if( gx_set_font( "nbold32.bdf"))        	// Ʈ 
		{
			gx_print_error("nbold32.bdf");
		} 
	}
	
	fwp_pen_color = gx_color(255,0,0,255);		// pen  Ѵ. 		
	
	if( ex_init( EX_WAIT_TIME_DEFAULT ) )		// ex lib ʱȭ Ѵ.					
	{
		ex_print_error("\n");
		exit(0);
	}

	if( ix_init() )								// ix lib ʱȭѴ.
	{
		ix_print_error(" ");
		return -1;
	}

	if(ix_auto_scan_open(IX_TMP_PATH_DEFAULT))	 // Է ̹ ڵ˻  openó
	{
		ix_print_error(" ");
		return -1;
	}	


	return 0;
}
 
//--------------------------------------------------------------
//  : 콺  ȭ鿡 ǥϴ Դϴ. 
//--------------------------------------------------------------
int main( int argc, char **argv )
{	
	fwp_init();	

	fwp_lib_setting();										// fwp ϴ ̺귯 ʱȭ 	
 
	ix_add_event( fwp_ix_event_handler );					// ̺Ʈ óԼ Ѵ.	
	
	while( 1 )
	{
		if( ex_loop() )
		{
			 ex_print_error("\n");
			 exit(0);
		}
	}	
	gx_close();

	return 0;
}

